/*	
	Obsolete core functions
	Developer: Algorithmica Research			
*/
option(null: hard);	

number null_number()
option(category: 'Obsolete Functions/Basic Types and Functions')
{
	return null<number>;
}

date null_date()
option(category: 'Obsolete Functions/Basic Types and Functions')
{
	return null<date>;
}

timestamp null_timestamp()
option(category: 'Obsolete Functions/Basic Types and Functions')
{
	return null<timestamp>;
}

string null_string()
option(category: 'Obsolete Functions/Basic Types and Functions')
{
	return null<string>;
}

logical equali(string s, string s2) 
option(category: 'Obsolete Functions/Basic Types and Functions')
{ 
	return equal_casei(s,s2) ; 
}

date imm_date1(date d)
/* Third wednesday in each month */
{
	integer d_year = year(d);
	integer d_month = month(d);
	date imm_d = date(d_year, d_month, 14);
	integer a = integer(fmod(9 - weekday(imm_d), 7));
	return imm_d + a + 1;
	
}

date move_imm_dates1(date d, integer n)
{
	if(n==0) return d;
	
	integer d_year = year(d);
	integer d_month = month(d);
	//integer d_day = day(d);
	date imm_prel = imm_date1(d);
	if(((n>0) && (d >= imm_prel))||((n<0) && (d <= imm_prel))){
		imm_prel = date(d_year, d_month, 1);
		imm_prel = add_months(imm_prel, integer(sign(n)));
		imm_prel = imm_date1(imm_prel);
	}
	if(n>0) n--;
	if(n<0) n++;
	if(abs(n)>0){
		d_year = year(imm_prel);
		d_month = month(imm_prel);
		imm_prel = date(d_year, d_month, 1);
		imm_prel = add_months(imm_prel, n);
		imm_prel = imm_date1(imm_prel);
	}
	return imm_prel;
}


date move_imm_dates(date d, integer n)
option(category: 'Obsolete Functions/Basic Types and Functions/Date Manipulation')
{
	if(n==0) return d;

	date imm_prel = move_imm_dates1(d, integer(sign(n)));
	integer imm_month = month(imm_prel);
	number mod = fmod(imm_month, 3);
	if(!(mod==0)){
		if(sign(n) > 0){ mod = 3-mod;}
		else { mod = -mod;}
		integer imm_year = year(imm_prel);
		imm_prel = date(imm_year, imm_month, 1);
		imm_prel = add_months(imm_prel, integer(mod));
		imm_prel = imm_date1(imm_prel);	
	}
	if(n>0) n--;
	if(n<0) n++;
	if(abs(n)>0){
		imm_prel = move_imm_dates1(imm_prel, n*3);
	}
	return imm_prel;
}

date nth_weekday_date(integer n, integer weekday_num, date d)
option(category: 'Obsolete Functions/Basic Types and Functions/Date Manipulation')
{
	integer d_year = year(d);
	integer d_month = month(d);
	
	if((weekday_num <= 0)|| (n>7)) 
		throw(E_INVALID_ARG, 'Invalid weekday');

	if((n<=0) || (n>5))  
		throw(E_INVALID_ARG, 'Invalid day number n');
	
	date prel;	
	if(n> 1)
		prel = date(d_year, d_month, (n-1)*7);
	else 
		prel = date(d_year, d_month, 7) - 7;
	
	integer a = integer(fmod(weekday_num + 6 - weekday(prel), 7));
	prel = prel + a + 1;
	
	if(month(prel) != d_month)
		throw(E_INVALID_ARG, 'Invalid day number n');

	return prel;
}







