option(null: hard);	// Throw error if a null value is used in a non-nullable context
/*	
	LEGACY Code

	Basic swap functions for "dual" bootstrap
	Parameter classes
	Developed by Algorithmica Research, Magnus Nyström
	
	
	
	Comments:

	ToDo: 
	
*/

//-------------------------------------------------------
// class
// swap_curve_fwd_parm 
// legacy version
//-------------------------------------------------------
class swap_curve_fwd_parm : public  swap_curve_ext_parm option (category: 'Obsolete Functions/Yield Curve/003 Curve Building')
{
   	public:
		swap_curve_fwd_parm(curve option(nullable), curve option(nullable), curve option(nullable), 
							number option(nullable) ,logical,logical,logical,curve_prio,curve_prio,integer,vector(number) option(nullable));			
		/*swap_curve_fwd_parm(curve option(nullable), curve option(nullable), curve option(nullable), 
							number option(nullable) ,curve_blend_parm,vector(number) option(nullable));*/
		swap_curve_fwd_parm(swap_curve_fwd_parm);
		virtual swap_curve_type type() ;											
};

swap_curve_type swap_curve_fwd_parm.type() {return type_;}


swap_curve_fwd_parm.swap_curve_fwd_parm(curve option(nullable) 		short_crv,
										curve option(nullable) 		fra_crv,
										curve option(nullable)		swap_crv,
										number option(nullable) 	swap_first_fix,
										logical						no_overlap_fwd,
										logical						merge_fra,
										logical						merge_crv,
										curve_prio					prio1,
										curve_prio					prio2,
										integer						blend_buf_days,
										vector(number) option(nullable) edfut_cvx_adj) 
										:swap_curve_ext_parm(	short_crv, fra_crv, swap_crv, swap_first_fix, no_overlap_fwd, merge_fra,
																merge_crv, prio1, prio2, blend_buf_days, swap_curve_type.SCE_FWD, edfut_cvx_adj,true) 
{}	

/*swap_curve_fwd_parm.swap_curve_fwd_parm(curve option(nullable) 		short_crv,
										curve option(nullable) 		fra_crv,
										curve option(nullable)		swap_crv,
										number option(nullable) 	swap_first_fix,
										curve_blend_parm			crv_blend_parm,
										vector(number) option(nullable) edfut_cvx_adj) 
										:swap_curve_ext_parm(	short_crv, fra_crv, swap_crv, swap_first_fix, crv_blend_parm.no_overlap_fwd_, 
																crv_blend_parm.merge_fra_,crv_blend_parm.merge_crv_, crv_blend_parm.prio1_, 
																crv_blend_parm.prio2_, crv_blend_parm.blend_buf_days_, SCE_FWD, edfut_cvx_adj) 
{}
*/
swap_curve_fwd_parm.swap_curve_fwd_parm(swap_curve_fwd_parm s) :swap_curve_ext_parm(s)
{}
//-------------------------------------------------------
// create swap_curve_fwd_parm
//-------------------------------------------------------
swap_curve_fwd_parm swap_curve_fwd_parm(curve option(nullable) 		short_crv,
										curve option(nullable) 		fra_crv,
										curve option(nullable)		swap_crv,
										number option(nullable) 	swap_first_fix,
										logical						no_overlap_fwd,
										logical						merge_fra,
										logical						merge_crv,
										curve_prio					prio1,
										curve_prio					prio2,
										integer						blend_buf_days,
										vector(number) option(nullable) edfut_cvx_adj = null<vector(number)>) 
							
{					
	return new swap_curve_fwd_parm(	short_crv, fra_crv, swap_crv, swap_first_fix, no_overlap_fwd, merge_fra,
									merge_crv, prio1, prio2, blend_buf_days, edfut_cvx_adj);	
}
//-------------------------------------------------------
// create swap_curve_fwd_parm
//-------------------------------------------------------
/*swap_curve_fwd_parm swap_curve_fwd_parm(curve option(nullable) 		short_crv,
										curve option(nullable) 		fra_crv,
										curve option(nullable)		swap_crv,										
										curve_blend_parm			crv_blend_parm,
										number option(nullable) 	swap_first_fix = null<number>,
										vector(number) option(nullable) edfut_cvx_adj = null<vector(number)>) 
							
{					
	return new swap_curve_fwd_parm(	short_crv, fra_crv, swap_crv, swap_first_fix, crv_blend_parm, edfut_cvx_adj);	
}
*/
//-------------------------------------------------------
// class
// swap_curve_b2_parm 
// legacy version
//-------------------------------------------------------
class swap_curve_b2_parm : public  swap_curve_ext_parm option (category: 'Obsolete Functions/Yield Curve/003 Curve Building')
{
   	public:
		swap_curve_b2_parm(	curve option(nullable), curve option(nullable), curve, curve , number option(nullable) ,
							logical,logical,logical,curve_prio,curve_prio,integer,vector(number) option(nullable));			
	
		swap_curve_b2_parm(swap_curve_b2_parm);
		virtual swap_curve_type	type() ;
		curve basis_crv_;											
};

swap_curve_type swap_curve_b2_parm.type() {return type_;}

swap_curve_b2_parm.swap_curve_b2_parm(	curve option(nullable) 		short_crv,
										curve option(nullable) 		fra_crv,
										curve 						swap_crv,
										curve 						basis_crv,
										number option(nullable) 	swap_first_fix,											
										logical						no_overlap_fwd,
										logical						merge_fra,
										logical						merge_crv,
										curve_prio					prio1,
										curve_prio					prio2,
										integer						blend_buf_days,
										vector(number) option(nullable) edfut_cvx_adj) 
										:swap_curve_ext_parm(	short_crv, fra_crv, swap_crv, swap_first_fix, no_overlap_fwd, merge_fra,
																merge_crv, prio1, prio2, blend_buf_days, swap_curve_type.SCE_FWD_B2, edfut_cvx_adj,true),
										 basis_crv_(basis_crv) 
{}	

swap_curve_b2_parm.swap_curve_b2_parm(swap_curve_b2_parm s) :swap_curve_ext_parm(s), basis_crv_(s.basis_crv_)
{}


swap_curve_b2_parm swap_curve_b2_parm(	curve option(nullable) 		short_crv,
										curve option(nullable) 		fra_crv,
										curve 						swap_crv,
										curve 						basis_crv,
										number option(nullable) 	swap_first_fix,
										logical						no_overlap_fwd,
										logical						merge_fra,
										logical						merge_crv,
										curve_prio					prio1,
										curve_prio					prio2,
										integer						blend_buf_days,
										vector(number) option(nullable) edfut_cvx_adj = null<vector(number)>) 
										
{					
	return new swap_curve_b2_parm(	short_crv, fra_crv, swap_crv, basis_crv, swap_first_fix, no_overlap_fwd, merge_fra,
									merge_crv, prio1, prio2, blend_buf_days, edfut_cvx_adj);	
}

/*-----------------------------------------------------------------------
  Name :    class swap_curve_b1_parm
  Notes :   legacy version        
  Changes:
  			Date    		Who     Detail
  			? 				MN      Original code (moved from fiws)
  ----------------------------------------------------------------------*/
class swap_curve_b1_parm : public  swap_curve_ext_parm option (category: 'Obsolete Functions/Yield Curve/003 Curve Building')
{
   	public:
		swap_curve_b1_parm(	curve option(nullable), curve option(nullable), curve, number option(nullable) ,number option(nullable), 
							logical,logical,logical,curve_prio,curve_prio,integer,vector(number) option(nullable));			
	
		swap_curve_b1_parm(swap_curve_b1_parm);
		
		virtual swap_curve_type		type();
		curve 	basis_crv_;	
		number	basis_first_fix_flat_;
		number	basis_first_fix_base_;											
};

swap_curve_type swap_curve_b1_parm.type() {return type_;}

swap_curve_b1_parm.swap_curve_b1_parm(	curve option(nullable) 		short_crv,
										curve option(nullable) 		fra_crv,												
										curve 						basis_crv,												
										number option(nullable)		basis_first_fix_flat,
										number option(nullable)		basis_first_fix_base,												
										logical						no_overlap_fwd,
										logical						merge_fra,
										logical						merge_crv,
										curve_prio					prio1,
										curve_prio					prio2,
										integer						blend_buf_days,
										vector(number) option(nullable) edfut_cvx_adj) 
										:swap_curve_ext_parm(	short_crv, fra_crv, null<curve>, null<number>, no_overlap_fwd, merge_fra,
																merge_crv, prio1, prio2, blend_buf_days, swap_curve_type.SCE_FWD_B1, edfut_cvx_adj,true),
										 basis_crv_(basis_crv), basis_first_fix_flat_(basis_first_fix_flat), basis_first_fix_base_(basis_first_fix_base) 
{}	

swap_curve_b1_parm.swap_curve_b1_parm(swap_curve_b1_parm s) 
									:swap_curve_ext_parm(s), basis_crv_(s.basis_crv_), basis_first_fix_flat_(s.basis_first_fix_flat_),
									 basis_first_fix_base_(s.basis_first_fix_base_)
{}


swap_curve_b1_parm swap_curve_b1_parm(	curve option(nullable) 		short_crv,
										curve option(nullable) 		fra_crv,													
										curve 						basis_crv,
										number	option(nullable)	basis_first_fix_flat,
										number	option(nullable)	basis_first_fix_base,	
										logical						no_overlap_fwd,
										logical						merge_fra,
										logical						merge_crv,
										curve_prio					prio1,
										curve_prio					prio2,
										integer						blend_buf_days,
										vector(number) option(nullable) edfut_cvx_adj = null<vector(number)>) 
										
{					
	return new swap_curve_b1_parm(	short_crv, fra_crv, basis_crv,  basis_first_fix_flat,basis_first_fix_base, no_overlap_fwd, merge_fra,
									merge_crv, prio1, prio2, blend_buf_days, edfut_cvx_adj);	
}


//-------------------------------------------------------
// class
// swap_curve_cb1_parm
// legacy version
//-------------------------------------------------------
class swap_curve_cb1_parm : public  swap_curve_ext_parm option (category: 'Obsolete Functions/Yield Curve/003 Curve Building')
{
   	public:
		swap_curve_cb1_parm(fx_spot option(nullable), curve option(nullable), instr_class_name option(nullable),instr_class_name option(nullable),
							curve, number option(nullable) ,number option(nullable),logical,logical,integer);			
	
		swap_curve_cb1_parm(swap_curve_cb1_parm);
		virtual swap_curve_type	type() ;

		curve 				basis_crv_;
		number				basis_first_fix_flat_;
		number				basis_first_fix_sprd_;	
		fx_spot				fx_spot_;
		instr_class_name 	depo_class_fxbase_;
		instr_class_name 	depo_class_fxprice_;	
											
};

swap_curve_type swap_curve_cb1_parm.type() {return type_;}

swap_curve_cb1_parm.swap_curve_cb1_parm(	fx_spot option(nullable)	fx_sp,
											curve option(nullable) 		fxswap_crv,			
											instr_class_name option(nullable) depo_class_fxbase,
											instr_class_name option(nullable) depo_class_fxprice,								
											curve 						basis_crv,											
											number option(nullable)		basis_first_fix_flat,
											number option(nullable)		basis_first_fix_sprd,											
											logical						merge_crv,
											logical						prio_fxswap,											
											integer						blend_buf_days) 
											:swap_curve_ext_parm(	fxswap_crv, null<curve>, null<curve>, null<number>, false, false,
																	merge_crv, (prio_fxswap? curve_prio.SHORT : curve_prio.MIDDLE),
																	(prio_fxswap? curve_prio.MIDDLE : curve_prio.SHORT), blend_buf_days, swap_curve_type.SCE_CURR_B1,
																	null<vector(number)>,false),
											 basis_crv_(basis_crv), basis_first_fix_flat_(basis_first_fix_flat), basis_first_fix_sprd_(basis_first_fix_sprd),
											 fx_spot_(null(fx_sp) ? null<fx_spot> :fx_sp) ,depo_class_fxbase_(depo_class_fxbase), depo_class_fxprice_(depo_class_fxprice)											 
{}	

swap_curve_cb1_parm.swap_curve_cb1_parm(swap_curve_cb1_parm s) 
										:swap_curve_ext_parm(s), basis_crv_(s.basis_crv_), basis_first_fix_flat_(s.basis_first_fix_flat_),
									 	 basis_first_fix_sprd_(s.basis_first_fix_sprd_),fx_spot_(s.fx_spot_), depo_class_fxbase_(s.depo_class_fxbase_), 
										 depo_class_fxprice_(s.depo_class_fxprice_)

{}

//-------------------------------------------------------
// create swap_curve_cb1_parm
//-------------------------------------------------------
/*swap_curve_cb1_parm swap_curve_cb1_parm(	fx_spot option(nullable)	fx_spot,
											curve option(nullable) 		fxswap_crv,
											instr_class_name option(nullable) depo_class_fxbase,
											instr_class_name option(nullable) depo_class_fxprice,												
											curve 						basis_crv,											
											number option(nullable)		basis_first_fix_flat,
											number option(nullable)		basis_first_fix_sprd,											
											logical						merge_crv,
											logical						prio_fxswap,											
											integer						blend_buf_days) 
										
{					
	return new swap_curve_cb1_parm(	fx_spot, fxswap_crv,  depo_class_fxbase, depo_class_fxprice,basis_crv,
									basis_first_fix_flat, basis_first_fix_sprd,
									merge_crv, prio_fxswap, blend_buf_days);	
}*/

swap_curve_cb1_parm swap_curve_cb1_parm(	instrument option(nullable)	fx_sp,
											curve option(nullable) 		fxswap_crv,
											instr_class_name option(nullable) depo_class_fxbase,
											instr_class_name option(nullable) depo_class_fxprice,												
											curve 						basis_crv,											
											number option(nullable)		basis_first_fix_flat,
											number option(nullable)		basis_first_fix_sprd,											
											logical						merge_crv,
											logical						prio_fxswap,											
											integer						blend_buf_days) 
										
{
	fx_spot fxs = null(fx_sp) ? null<fx_spot> : fx_spot(fx_sp);
	
	return new swap_curve_cb1_parm(	fxs, fxswap_crv,  depo_class_fxbase, depo_class_fxprice,basis_crv,
									basis_first_fix_flat, basis_first_fix_sprd,
									merge_crv, prio_fxswap, blend_buf_days);	
}

//-------------------------------------------------------
// class
// swap_curve_cff_parm
// legacy version
//-------------------------------------------------------
class swap_curve_cff_parm : public  swap_curve_ext_parm option (category: 'Obsolete Functions/Yield Curve/003 Curve Building')
{
   	public:
		swap_curve_cff_parm(fx_spot option(nullable), curve option(nullable), instr_class_name option(nullable),instr_class_name option(nullable),
							curve, number option(nullable),logical,logical,integer);			
	
		swap_curve_cff_parm(swap_curve_cff_parm);
		virtual swap_curve_type	type() ;

		curve 				fixflt_crv_;
		number				flt_first_fix_;		
		fx_spot				fx_spot_;
		instr_class_name 	depo_class_fxbase_;
		instr_class_name 	depo_class_fxprice_;											
};

swap_curve_type swap_curve_cff_parm.type() {return type_;}


swap_curve_cff_parm.swap_curve_cff_parm(	fx_spot option(nullable)	fx_sp,
											curve option(nullable) 		fxswap_crv,			
											instr_class_name option(nullable) depo_class_fxbase,
											instr_class_name option(nullable) depo_class_fxprice,								
											curve 						fixflt_crv,
											number option(nullable)		flt_first_fix,											
											logical						merge_crv,
											logical						prio_fxswap,											
											integer						blend_buf_days) 
											:swap_curve_ext_parm(	fxswap_crv, null<curve>, null<curve>, null<number>, false, false,
																	merge_crv, (prio_fxswap? curve_prio.SHORT : curve_prio.MIDDLE),
																	(prio_fxswap? curve_prio.MIDDLE : curve_prio.SHORT), blend_buf_days, swap_curve_type.SCE_CURR_FF,
																	null<vector(number)>,false),
											 fixflt_crv_(fixflt_crv), flt_first_fix_(flt_first_fix), fx_spot_(fx_spot(fx_sp)) ,depo_class_fxbase_(depo_class_fxbase), depo_class_fxprice_(depo_class_fxprice)
{}	


swap_curve_cff_parm.swap_curve_cff_parm(swap_curve_cff_parm s) 
										:swap_curve_ext_parm(s), fixflt_crv_(s.fixflt_crv_), flt_first_fix_(s.flt_first_fix_),
									 	 fx_spot_(s.fx_spot_), depo_class_fxbase_(s.depo_class_fxbase_), 
										 depo_class_fxprice_(s.depo_class_fxprice_)
{}

//-------------------------------------------------------
// create swap_curve_cff_parm
//-------------------------------------------------------
swap_curve_cff_parm swap_curve_cff_parm(	fx_spot option(nullable)	fx_spot,
											curve option(nullable) 		fxswap_crv,
											instr_class_name option(nullable) depo_class_fxbase,
											instr_class_name option(nullable) depo_class_fxprice,												
											curve 						fixflt_crv,
											number option(nullable)		flt_first_fix,										
											logical						merge_crv,
											logical						prio_fxswap,											
											integer						blend_buf_days) 
										
{					
	return new swap_curve_cff_parm(	fx_spot, fxswap_crv,  depo_class_fxbase, depo_class_fxprice,fixflt_crv, flt_first_fix, 
									merge_crv, prio_fxswap, blend_buf_days);	
}
